libstdc++: __gnu_cxx::__alloc_traits< _Alloc, typename > Struct Template Reference

libstdc++

__gnu_cxx::__alloc_traits< _Alloc, typename > Struct Template Reference
Utilities » Memory » Allocators

`#include <alloc_traits.h>`

Inheritance diagram for __gnu_cxx::__alloc_traits< _Alloc, typename >:
[legend]

## Public Types
typedef std::allocator_traits< _Alloc > | _Base_type
typedef _Alloc | allocator_type
typedef _Base_type::const_pointer | const_pointer
typedef const value_type & | const_reference
using | const_void_pointer
typedef _Base_type::difference_type | difference_type
using | is_always_equal
typedef _Base_type::pointer | pointer
using | propagate_on_container_copy_assignment
using | propagate_on_container_move_assignment
using | propagate_on_container_swap
template<typename _Tp>
using | rebind_alloc
template<typename _Tp>
using | rebind_traits
typedef value_type & | reference
typedef _Base_type::size_type | size_type
typedef _Base_type::value_type | value_type
using | void_pointer

## Static Public Member Functions
static constexpr bool | _S_always_equal ()
static constexpr bool | _S_nothrow_move ()
static constexpr void | _S_on_swap (_Alloc &__a, _Alloc &__b)
static constexpr bool | _S_propagate_on_copy_assign ()
static constexpr bool | _S_propagate_on_move_assign ()
static constexpr bool | _S_propagate_on_swap ()
static constexpr _Alloc | _S_select_on_copy (const _Alloc &__a)
static constexpr pointer | allocate (_Alloc &__a, size_type __n)
static constexpr pointer | allocate (_Alloc &__a, size_type __n, const_void_pointer __hint)
static constexpr pointer | allocate (_Alloc &__a, size_type __n)
static constexpr pointer | allocate (_Alloc &__a, size_type __n, const_void_pointer __hint)
static constexpr auto | allocate_at_least (_Alloc &__a, size_type __n) -> allocation_result< pointer, size_type >
template<typename _Ptr, typename... _Args>
static constexpr std::__enable_if_t< __is_custom_pointer< _Ptr >::value > | construct (_Alloc &__a, _Ptr __p, _Args &&... __args) noexcept(noexcept(_Base_type::construct(__a, std::__to_address(__p), std::forward< _Args >(__args)...)))
template<typename _Tp, typename... _Args> requires __can_construct<_Alloc, _Tp, _Args...>
static constexpr void | construct (_Alloc &__a, _Tp *__p, _Args &&... __args) noexcept(_S_nothrow_construct< _Tp, _Args... >())
static constexpr void | deallocate (_Alloc &__a, pointer __p, size_type __n)
static constexpr void | deallocate (_Alloc &__a, pointer __p, size_type __n)
template<typename _Ptr>
static constexpr std::__enable_if_t< __is_custom_pointer< _Ptr >::value > | destroy (_Alloc &__a, _Ptr __p) noexcept(noexcept(_Base_type::destroy(__a, std::__to_address(__p))))
template<typename _Tp>
static constexpr void | destroy (_Alloc &__a, _Tp *__p) noexcept(_S_nothrow_destroy< _Tp >())
static constexpr size_type | max_size (const _Alloc &__a) noexcept
static constexpr _Alloc | select_on_container_copy_construction (const _Alloc &__rhs)

## Detailed Description

template<typename _Alloc, typename = typename _Alloc::value_type>
struct __gnu_cxx::__alloc_traits< _Alloc, typename >

Uniform interface to C++98 and C++11 allocators.

Definition at line 47 of file ext/alloc_traits.h.

## Member Typedef Documentation

## ◆ _Base_type

template<typename _Alloc, typename = typename _Alloc::value_type>

typedef std::allocator_traits<_Alloc> __gnu_cxx::__alloc_traits< _Alloc, typename >::_Base_type

Definition at line 54 of file ext/alloc_traits.h.

## ◆ allocator_type

template<typename _Alloc, typename = typename _Alloc::value_type>

typedef _Alloc __gnu_cxx::__alloc_traits< _Alloc, typename >::allocator_type

Definition at line 52 of file ext/alloc_traits.h.

## ◆ const_pointer

template<typename _Alloc, typename = typename _Alloc::value_type>

typedef _Base_type::const_pointer __gnu_cxx::__alloc_traits< _Alloc, typename >::const_pointer

Definition at line 57 of file ext/alloc_traits.h.

## ◆ const_reference

template<typename _Alloc, typename = typename _Alloc::value_type>

typedef const value_type& __gnu_cxx::__alloc_traits< _Alloc, typename >::const_reference

Definition at line 62 of file ext/alloc_traits.h.

## ◆ const_void_pointer

template<typename _Alloc>

using std::allocator_traits< _Alloc >::const_void_pointer
| inherited

The allocator's const void pointer type.

`Alloc::const_void_pointer` if that type exists, otherwise pointer_traits<pointer>::rebind<const void>

Definition at line 317 of file bits/alloc_traits.h.

## ◆ difference_type

template<typename _Alloc, typename = typename _Alloc::value_type>

typedef _Base_type::difference_type __gnu_cxx::__alloc_traits< _Alloc, typename >::difference_type

Definition at line 59 of file ext/alloc_traits.h.

## ◆ is_always_equal

template<typename _Alloc>

using std::allocator_traits< _Alloc >::is_always_equal
| inherited

Whether all instances of the allocator type compare equal.

`Alloc::is_always_equal` if that type exists, otherwise `is_empty<Alloc>::type`

Definition at line 365 of file bits/alloc_traits.h.

## ◆ pointer

template<typename _Alloc, typename = typename _Alloc::value_type>

typedef _Base_type::pointer __gnu_cxx::__alloc_traits< _Alloc, typename >::pointer

Definition at line 56 of file ext/alloc_traits.h.

## ◆ propagate_on_container_copy_assignment

template<typename _Alloc>

using std::allocator_traits< _Alloc >::propagate_on_container_copy_assignment
| inherited

How the allocator is propagated on copy assignment.

`Alloc::propagate_on_container_copy_assignment` if that type exists, otherwise `false_type`

Definition at line 341 of file bits/alloc_traits.h.

## ◆ propagate_on_container_move_assignment

template<typename _Alloc>

using std::allocator_traits< _Alloc >::propagate_on_container_move_assignment
| inherited

How the allocator is propagated on move assignment.

`Alloc::propagate_on_container_move_assignment` if that type exists, otherwise `false_type`

Definition at line 349 of file bits/alloc_traits.h.

## ◆ propagate_on_container_swap

template<typename _Alloc>

using std::allocator_traits< _Alloc >::propagate_on_container_swap
| inherited

How the allocator is propagated on swap.

`Alloc::propagate_on_container_swap` if that type exists, otherwise `false_type`

Definition at line 357 of file bits/alloc_traits.h.

## ◆ rebind_alloc

template<typename _Alloc>
template<typename _Tp>

using std::allocator_traits< _Alloc >::rebind_alloc
| inherited

Definition at line 368 of file bits/alloc_traits.h.

## ◆ rebind_traits

template<typename _Alloc>
template<typename _Tp>

using std::allocator_traits< _Alloc >::rebind_traits
| inherited

Definition at line 370 of file bits/alloc_traits.h.

## ◆ reference

template<typename _Alloc, typename = typename _Alloc::value_type>

typedef value_type& __gnu_cxx::__alloc_traits< _Alloc, typename >::reference

Definition at line 61 of file ext/alloc_traits.h.

## ◆ size_type

template<typename _Alloc, typename = typename _Alloc::value_type>

typedef _Base_type::size_type __gnu_cxx::__alloc_traits< _Alloc, typename >::size_type

Definition at line 58 of file ext/alloc_traits.h.

## ◆ value_type

template<typename _Alloc, typename = typename _Alloc::value_type>

typedef _Base_type::value_type __gnu_cxx::__alloc_traits< _Alloc, typename >::value_type

Definition at line 55 of file ext/alloc_traits.h.

## ◆ void_pointer

template<typename _Alloc>

using std::allocator_traits< _Alloc >::void_pointer
| inherited

The allocator's void pointer type.

`Alloc::void_pointer` if that type exists, otherwise pointer_traits<pointer>::rebind<void>

Definition at line 309 of file bits/alloc_traits.h.

## Member Function Documentation

## ◆ _S_always_equal()

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr bool __gnu_cxx::__alloc_traits< _Alloc, typename >::_S_always_equal | ( |  | ) |
| inlinestaticconstexpr

Definition at line 118 of file ext/alloc_traits.h.

## ◆ _S_nothrow_move()

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr bool __gnu_cxx::__alloc_traits< _Alloc, typename >::_S_nothrow_move | ( |  | ) |
| inlinestaticconstexpr

Definition at line 122 of file ext/alloc_traits.h.

## ◆ _S_on_swap()

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr void __gnu_cxx::__alloc_traits< _Alloc, typename >::_S_on_swap | ( | _Alloc & | __a,
|  | _Alloc & | __b )
| inlinestaticconstexpr

Definition at line 102 of file ext/alloc_traits.h.

## ◆ _S_propagate_on_copy_assign()

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr bool __gnu_cxx::__alloc_traits< _Alloc, typename >::_S_propagate_on_copy_assign | ( |  | ) |
| inlinestaticconstexpr

Definition at line 106 of file ext/alloc_traits.h.

## ◆ _S_propagate_on_move_assign()

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr bool __gnu_cxx::__alloc_traits< _Alloc, typename >::_S_propagate_on_move_assign | ( |  | ) |
| inlinestaticconstexpr

Definition at line 110 of file ext/alloc_traits.h.

## ◆ _S_propagate_on_swap()

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr bool __gnu_cxx::__alloc_traits< _Alloc, typename >::_S_propagate_on_swap | ( |  | ) |
| inlinestaticconstexpr

Definition at line 114 of file ext/alloc_traits.h.

## ◆ _S_select_on_copy()

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr _Alloc __gnu_cxx::__alloc_traits< _Alloc, typename >::_S_select_on_copy | ( | const _Alloc & | __a | ) |
| inlinestaticconstexpr

Definition at line 98 of file ext/alloc_traits.h.

## ◆ allocate() [1/4]

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n )
| inlinestaticnodiscardconstexpr

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.

Calls `a.allocate(n)`

Definition at line 380 of file bits/alloc_traits.h.

## ◆ allocate() [2/4]

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n,
|  | const_void_pointer | __hint )
| inlinestaticnodiscardconstexpr

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.
  __hint | Aid to locality.

Returns
  Memory of suitable size and alignment for n objects of type `value_type`

Returns a.allocate(n, hint) if that expression is well-formed, otherwise returns `a.allocate(n)`

Definition at line 395 of file bits/alloc_traits.h.

## ◆ allocate() [3/4]

template<typename _Alloc>

constexpr pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n )
| inlinestaticnodiscardconstexprinherited

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.

Calls `a.allocate(n)`

Definition at line 380 of file bits/alloc_traits.h.

## ◆ allocate() [4/4]

template<typename _Alloc>

constexpr pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n,
|  | const_void_pointer | __hint )
| inlinestaticnodiscardconstexprinherited

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.
  __hint | Aid to locality.

Returns
  Memory of suitable size and alignment for n objects of type `value_type`

Returns a.allocate(n, hint) if that expression is well-formed, otherwise returns `a.allocate(n)`

Definition at line 395 of file bits/alloc_traits.h.

## ◆ allocate_at_least()

template<typename _Alloc>

constexpr auto std::allocator_traits< _Alloc >::allocate_at_least | ( | _Alloc & | __a,
|  | size_type | __n ) -> allocation_result<pointer, size_type>
| inlinestaticnodiscardconstexprinherited

Allocate memory, generously.

Parameters

  __a | An allocator.
  __n | The minimum number of objects to allocate space for.

Returns
  Memory of suitable size and alignment for n or more contiguous objects of type value_type.

Returns a.allocate_at_least(n) if that expression is well-formed, else { a.allocate(n), n }. When an allocator is obliged to reserve more space than required for the cited n objects, it may deliver the extra space to the caller.

Definition at line 417 of file bits/alloc_traits.h.

## ◆ construct() [1/2]

template<typename _Alloc, typename = typename _Alloc::value_type>
template<typename _Ptr, typename... _Args>

constexpr std::__enable_if_t< __is_custom_pointer< _Ptr >::value > __gnu_cxx::__alloc_traits< _Alloc, typename >::construct | ( | _Alloc & | __a,
|  | _Ptr | __p,
|  | _Args &&... | __args )
| inlinestaticconstexprnoexcept

Definition at line 80 of file ext/alloc_traits.h.

## ◆ construct() [2/2]

template<typename _Alloc, typename = typename _Alloc::value_type>
template<typename _Tp, typename... _Args>
requires __can_construct<_Alloc, _Tp, _Args...>

constexpr void std::allocator_traits< _Alloc >::construct | ( | _Alloc & | __a,
|  | _Tp * | __p,
|  | _Args &&... | __args )
| inlinestaticconstexprnoexcept

Construct an object of type _Tp

Parameters

  __a | An allocator.
  __p | Pointer to memory of suitable size and alignment for Tp
  __args | Constructor arguments.

Calls __a.construct(__p, std::forward<Args>(__args)...) if that expression is well-formed, otherwise uses placement-new to construct an object of type _Tp at location __p from the arguments __args...

Definition at line 457 of file bits/alloc_traits.h.

## ◆ deallocate() [1/2]

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr void std::allocator_traits< _Alloc >::deallocate | ( | _Alloc & | __a,
|  | pointer | __p,
|  | size_type | __n )
| inlinestaticconstexpr

Deallocate memory.

Parameters

  __a | An allocator.
  __p | Pointer to the memory to deallocate.
  __n | The number of objects space was allocated for.

Calls a.deallocate(p, n)

Definition at line 436 of file bits/alloc_traits.h.

## ◆ deallocate() [2/2]

template<typename _Alloc>

constexpr void std::allocator_traits< _Alloc >::deallocate | ( | _Alloc & | __a,
|  | pointer | __p,
|  | size_type | __n )
| inlinestaticconstexprinherited

Deallocate memory.

Parameters

  __a | An allocator.
  __p | Pointer to the memory to deallocate.
  __n | The number of objects space was allocated for.

Calls a.deallocate(p, n)

Definition at line 436 of file bits/alloc_traits.h.

## ◆ destroy() [1/2]

template<typename _Alloc, typename = typename _Alloc::value_type>
template<typename _Ptr>

constexpr std::__enable_if_t< __is_custom_pointer< _Ptr >::value > __gnu_cxx::__alloc_traits< _Alloc, typename >::destroy | ( | _Alloc & | __a,
|  | _Ptr | __p )
| inlinestaticconstexprnoexcept

Definition at line 93 of file ext/alloc_traits.h.

## ◆ destroy() [2/2]

template<typename _Alloc, typename = typename _Alloc::value_type>
template<typename _Tp>

constexpr void std::allocator_traits< _Alloc >::destroy | ( | _Alloc & | __a,
|  | _Tp * | __p )
| inlinestaticconstexprnoexcept

Destroy an object of type _Tp.

Parameters

  __a | An allocator.
  __p | Pointer to the object to destroy

Calls `__a.destroy(__p)` if that expression is well-formed, otherwise calls `__p->~_Tp()`

Definition at line 476 of file bits/alloc_traits.h.

## ◆ max_size()

template<typename _Alloc, typename = typename _Alloc::value_type>

constexpr size_type std::allocator_traits< _Alloc >::max_size | ( | const _Alloc & | __a | ) |
| inlinestaticconstexprnoexcept

The maximum supported allocation size.

Parameters

  __a | An allocator.

Returns
  `__a.max_size()` or `numeric_limits<size_type>::max()`

Returns `__a.max_size()` if that expression is well-formed, otherwise returns `numeric_limits<size_type>::max()`

Definition at line 494 of file bits/alloc_traits.h.

## ◆ select_on_container_copy_construction()

template<typename _Alloc>

constexpr _Alloc std::allocator_traits< _Alloc >::select_on_container_copy_construction | ( | const _Alloc & | __rhs | ) |
| inlinestaticconstexprinherited

Obtain an allocator to use when copying a container.

Parameters

  __rhs | An allocator.

Returns
  `__rhs.select_on_container_copy_construction()` or __rhs

Returns `__rhs.select_on_container_copy_construction()` if that expression is well-formed, otherwise returns __rhs

Definition at line 514 of file bits/alloc_traits.h.

The documentation for this struct was generated from the following file:

- ext/alloc_traits.h